<script>
import { Doughnut } from 'vue-chartjs';

export default {
  extends: Doughnut,
  props: {
    donnee: {
      type: Array,
      default: () => [0, 0, 0, 0, 0],
    },
    titreText: {
      type: String,
      default: '',
    },
    label: {
      type: Array,
      default: () => [],
    },
    displayTitre: Boolean,
    displayLegend: Boolean,
  },
  data() {
    return {
      chartData: {
        labels: this.label,
        datasets: [
          {
            backgroundColor: ['#8c7f7f', '#973CB9', '#91c000', '#ff9a00', '#12b9f4'],
            data: this.donnee,
          },
        ],
      },
      options: {
        responsive: true,
        maintainAspectRatio: false,
        title: {
          display: this.displayTitre,
          fontSize: 18,
          text: this.titreText,
        },
        legend: {
          display: this.displayLegend,
        },
      },
    };
  },
  watch: {
    donnee: {
      handler() {
        this.update();
        this.renderChart(this.chartData, this.options);
      },
    },
  },
  mounted() {
    this.renderChart(this.chartData, this.options);
  },
  methods: {
    update() {
      this.options.title.text = this.titreText;
      this.options.title.display = this.displayTitre;
      this.options.legend.display = this.displayLegend;
      this.chartData.datasets[0].data = this.donnee;
      this.chartData.labels = this.label;
    },
  },
};
</script>

<style scoped></style>
